#!/usr/bin/perl
use strict;

open (INF, "<MERGE.OLD") or die "$!";
while(<INF>){
	last if (/;/);
}
my @cur_db;
my @dest_db;
my @hdeltat;
my @hstartt;
use constant nhar_m => 16;
use constant dbsiz => nhar_m+1;
for (0 .. dbsiz-1) {
	$cur_db[$_]=0;
	$dest_db[$_]=0;
	$hdeltat[$_]=0;
	$hstartt[$_]=0;
}
$dest_db[dbsiz-1]=-5161;
my @db;
my $time=0;
	
	
while(<INF>){
	if (/DB      0C(.)H,.(..)H,.(..)H/){ #harmonic 1/4 decibels
		#print hex($1)," $2,$3,\n";
		my $harm = hex($1);
		$dest_db[$harm]=hex($2);
		$hdeltat[$harm]=hex($3);
		$hstartt[$harm]=$time;
	}elsif (/DB       80H,.(.)(.)H,.(..)H,.(..)H/){ #freq 1/64 semitones
		#print $_;
		my $msb=hex($2);
		my $lsb=hex($3);
		my $freq=$msb*256+$lsb;
		if ($1 == "F"){
			$freq=-(2**13-$freq);
		}
		printf("%d ", $freq);
		$dest_db[dbsiz-1]=$freq;
		$hdeltat[dbsiz-1]=hex($4);
		$hstartt[dbsiz-1]=$time;

	}elsif (/DB       (..)H/){ #time delta 
		#print $_;
		my $delta=hex($1);
		for (1 .. $delta){
			my $inc=$_;
			for (0 .. dbsiz-1){
				my $harm = $_;
				my $dt = $hdeltat[$harm];
				my $startt = $hstartt[$harm];
				my $endt = $startt+$dt;
				my $curt = $time +$inc;
				my $val;
				if ($curt < $endt){
					my $rat=($curt-$startt)/$dt;
					$val = (1-$rat)*$cur_db[$harm]+$rat*$dest_db[$harm];
				} else {
					$val = $dest_db[$harm];
					$cur_db[$harm] = $val;
				}
				$db[$harm+($time+$inc)*dbsiz] = $val;
				#printf ("%d ",int($val)) if ($harm==dbsiz-1);
			}

		}
		$time += $delta
		#print $_;
	}elsif (/DB      0B0H/){ #end of data
		#print $_;
		last;
	}else {
		die "unrecognized format: $_";
	}

}

print $#db;
open (OUTF,">amy.au") or die("$!");
binmode OUTF;

print OUTF ".snd"; #magic
print OUTF pack("N",24); #offset to start of data
print OUTF pack("N",0xffffffff); #length unspecified
print OUTF pack("N",3); #16 bit PCM
print OUTF pack("N",44100); #rate
print OUTF pack("N",1); #1 channel

use constant PI => 4*atan2(1,1);#3.14159265358979323846;
my $theta=0;
my $freq1 = -5161;#$db[1x2*dbsiz+dbsiz-1];
print ("XXX:",$freq1,"\n");
my $timefactor = 11;
for (1...$timefactor*($#db+1)/dbsiz){
	my $i=$_;
	my $j=sin(((2*PI*$i/44100)*10));
	die if $j<-1;
	die if $j>1;

	my $time = int($i/$timefactor+1);
	my $freq=$db[$time*dbsiz+dbsiz-1];
	my $freqdiff=$freq-$freq1;
	my $basefreq=110;
	my $logbasefreq = log($basefreq);
	#exp(12x+log(n))=2*n;
	#exp(12x+log(n))=exp(log(2*n))
	#12x+log(n)=log(2*n)
	#12x+log(n)=log(n)+log(2)
	#12x=log(2)
	#x=log(2)/12
	my $logsemitone = log(2)/12;
	my $logataritone = $logsemitone/64;
	my $logfreqdiff = $freqdiff*$logataritone;
	my $logadjfreq = $logbasefreq + $logfreqdiff;
	my $adjfreq = exp($logadjfreq);


	#$theta+=(2*PI/44100)*(440+0*$j);
	$theta+=(2*PI/44100)*($adjfreq+0*$j);
	my $outvol=0;
	for (0..nhar_m-1){
		my $vol = $db[$_ + $time*dbsiz];
		#printf ("%2X ",int($vol));
		$outvol +=  10000/256/nhar_m*$vol*sin(($_+1)*$theta);
	}
	print OUTF pack("n",$outvol);
	#print OUTF pack("n",10000*sin($theta));#(2*PI*$i/44100)*(220+.1*$j)));
}
system ("chmod 777 amy.au");
		


